<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
        <el-form-item label="漫画名称">
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.bookName" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="推荐类别">
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.topic" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="创建时间">
          <el-date-picker
            v-model="queryParams.beginCreateTime"
            type="date"
            placeholder="开始日期"
            class="baseInput"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            style="width: 200px;"
          >
          </el-date-picker>
          <span> - </span>
          <el-date-picker
            v-model="queryParams.endCreateTime"
            type="date"
            placeholder="结束日期"
            class="baseInput"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            style="width: 200px;"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="作者">
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.author" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="标签">
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.tag" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="更新日期">
          <el-date-picker
            v-model="queryParams.beginUpdateTime"
            type="date"
            placeholder="开始日期"
            class="baseInput"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            style="width: 200px;"
          >
          </el-date-picker>
          <span> - </span>
          <el-date-picker
            v-model="queryParams.endUpdateTime"
            type="date"
            placeholder="结束日期"
            class="baseInput"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            style="width: 200px;"
          >
          </el-date-picker>
        </el-form-item>
        <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">查询</el-button>
      </el-form>
    </div>

    <el-table :data="tableData" style="width:100%"
              @selection-change="handleSelectionChange"
              @sort-change="changeSort"
              :default-sort="{prop: 'sort', order: 'descending'}"
              class="show_table" >
      <el-table-column label="漫画ID" width="80" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.id }}</span>
        </template>
      </el-table-column>
      <el-table-column label="漫画名称" width="180" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.title }}</span>
        </template>
      </el-table-column>
      <el-table-column label="作者" width="100" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.author }}</span>
        </template>
      </el-table-column>
      <el-table-column label="推荐类别" width="250" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-for="(element, index) in scope.row.topics">
            <span v-if="index != 0">, </span><span>{{ element }}</span>
          </span>
        </template>
      </el-table-column>
      <el-table-column label="标签" width="250" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-for="(element, index) in scope.row.tags">
            <span v-if="index != 0">, </span><span>{{ element }}</span>
          </span>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" width="180" align="center" prop="createdAt" sortable="custom" :sort-by="['createdAt']">
        <template slot-scope="scope">
          <span>{{ scope.row.createdAt }}</span>
        </template>
      </el-table-column>
      <el-table-column label="更新时间" width="180" align="center" prop="updatedAt" sortable="custom" :sort-by="['updatedAt']">
        <template slot-scope="scope">
          <span>{{ scope.row.updatedAt }}</span>
        </template>
      </el-table-column>
      <el-table-column label="来源" width="150" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>茄子动漫社</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" min-width="100" fixed="right" align="center">
        <template slot-scope="scope">
          <router-link :to="{path: '/books/booksChapter', query: {bookId:scope.row.id,bookName:scope.row.title,author:scope.row.author}}">
            <button>查看章节</button>
          </router-link>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>

  </div>
</template>

<script>
import {
  getBooksList,
} from "@/api/booksAdmin";

export default {
  data() {
    return {
      queryParams:{//查询参数
        bookName: "", //漫画名称
        tag: "",
        topic: "", //
        author: "",
        beginCreateTime: "", //创建时间-开始
        endCreateTime: "", //创建时间-结束
        beginUpdateTime: "", //创建时间-开始
        endUpdateTime: "", //创建时间-结束
      },
      multipleSelection: [], //多选，用于批量删除
      tableData: [],
      currentPage: 1,
      pageSize: 40,
      total: 0, //总数量
      orderByDescColumn: "", // 降序字段
      orderByAscColumn: "", // 升序字段
    };
  },
  created() {
    this.booksList();
  },
  methods: {
    // 从后台获取数据,重新排序
    changeSort (val) {
      // 根据当前排序重新获取后台数据,一般后台会需要一个排序的参数
      if(val.order == "ascending") {
        this.orderByAscColumn = val.prop
        this.orderByDescColumn = ""
      } else {
        this.orderByAscColumn = ""
        this.orderByDescColumn = val.prop
      }
      this.booksList()
    },
    booksList: function() {

      this.queryParams.currentPage = this.currentPage;
      this.queryParams.pageSize = this.pageSize;
      this.queryParams.orderByDescColumn = this.orderByDescColumn
      this.queryParams.orderByAscColumn = this.orderByAscColumn
      // console.log("订单查询参数="+JSON.stringify(this.queryParams))
      getBooksList(this.queryParams).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },


    handleFind: function() {
      this.currentPage = 1
      this.booksList();
    },

    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.booksList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.booksList();
    },

    // 改变多选
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },

  }
};
</script>
<style scoped>
  .el-form-item {
    margin-bottom: 10px;
  }
</style>
